// expresionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "expresion.h"
#include "expresionDlg.h"
#include "VarInsertDlg.h"
#include "VarValue.h"
#include "ExpValue.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExpresionDlg dialog

CExpresionDlg::CExpresionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExpresionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExpresionDlg)
	m_ExprStr = _T("");
	m_Result = 0.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExpresionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExpresionDlg)
	DDX_Text(pDX, IDC_EXPRESSION_EDIT, m_ExprStr);
	DDX_Text(pDX, IDC_RESULT_EDIT, m_Result);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExpresionDlg, CDialog)
	//{{AFX_MSG_MAP(CExpresionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnCalculate)
	ON_BN_CLICKED(IDC_BUTTON2, OnInsertVar)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExpresionDlg message handlers

BOOL CExpresionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_VarsMap.InitHashTable(100);
	m_expression.AtachVariables(&m_VarsMap);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CExpresionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExpresionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CExpresionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CExpresionDlg::OnCalculate() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	int result  = m_expression.ChangeExpression(m_ExprStr);
	if (result<0)
	{
		long result = m_expression.Value(m_Result);
		if (result == DIVISION_BY_0)
			AfxMessageBox(IDS_DIVBY0);

	}
	else 
	{
		// evaluation error
		CString errStr;
		errStr.Format (IDS_ERROR_AT,result);
		AfxMessageBox(errStr);
	}
	UpdateData(FALSE);
}

void CExpresionDlg::OnInsertVar() 
{
	// TODO: Add your control notification handler code here
	CVarInsertDlg dialog;
	dialog.m_pVarsMap = &m_VarsMap;
	dialog.DoModal();
}

void CExpresionDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	POSITION pos = m_VarsMap.GetStartPosition();
	while (pos != NULL)
	{
		CString sName;
		CValue *pVal;
		m_VarsMap.GetNextAssoc (pos, sName, pVal);
		delete pVal;
	}
	m_VarsMap.RemoveAll();	
}
